
      BLOCK DATA DT_HADPRP
 
      IMPLICIT NONE
      INTEGER k
      SAVE 
 
C auxiliary common for reggeon exchange (DTUNUC 1.x)
      INCLUDE 'inc/dtquar'
C hadron index conversion (BAMJET <--> PDG)
      INCLUDE 'inc/dthaic'
C names of hadrons used in input-cards
      INCLUDE 'inc/dtpain'
 
C / DTQUAR /
C***********************************************************************
C                                                                      *
C     Quark content of particles:                                      *
C          index   quark   el. charge  bar. charge  isospin  isospin3  *
C              1 = u          2/3          1/3        1/2       1/2    *
C             -1 = ubar      -2/3         -1/3        1/2      -1/2    *
C              2 = d         -1/3          1/3        1/2      -1/2    *
C             -2 = dbar       1/3         -1/3        1/2       1/2    *
C              3 = s         -1/3          1/3         0         0     *
C             -3 = sbar       1/3         -1/3         0         0     *
C              4 = c          2/3          1/3         0         0     *
C             -4 = cbar      -2/3         -1/3         0         0     *
C              5 = b         -1/3          1/3         0         0     *
C             -5 = bbar       1/3         -1/3         0         0     *
C              6 = t          2/3          1/3         0         0     *
C             -6 = tbar      -2/3         -1/3         0         0     *
C                                                                      *
C         Mquark = particle quark composition (Paprop numbering)       *
C         Iqechr = electric charge ( in 1/3 unit )                     *
C         Iqbchr = baryonic charge ( in 1/3 unit )                     *
C         Iqichr = isospin ( in 1/2 unit ), z component                *
C         Iqschr = strangeness                                         *
C         Iqcchr = charm                                               *
C         Iquchr = beauty                                              *
C         Iqtchr = ......                                              *
C                                                                      *
C***********************************************************************
      DATA IQEchr/ - 2 , 1 , -2 , 1 , 1 , -2 , 0 , 2 , -1 , -1 , 2 , 
     &     -1 , 2/
      DATA IQBchr/6* - 1 , 0 , 6*1/
      DATA IQIchr/4*0 , 1 , -1 , 0 , 1 , -1 , 4*0/
      DATA IQSchr/3*0 , 1 , 5*0 , -1 , 3*0/
      DATA IQCchr/2*0 , -1 , 7*0 , 1 , 2*0/
      DATA IQUchr/0 , 1 , 9*0 , -1 , 0/
      DATA IQTchr/ - 1 , 11*0 , 1/
      DATA MQUark/2 , 1 , 1 , -2 , -1 , -1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 
     &     0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 , 2 , 1 , -2 , -2 , -1 , 
     &     0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 1 , -2 , 0 , 2 , -1 , 0 , 
     &     1 , -3 , 0 , 3 , -1 , 0 , 1 , 2 , 3 , -1 , -2 , -3 , 0 , 0 , 
     &     0 , 2 , 2 , 3 , 1 , 1 , 3 , 1 , 2 , 3 , 1 , -1 , 0 , 2 , -3 , 
     &     0 , 3 , -2 , 0 , 2 , -2 , 0 , 3 , -3 , 0 , 0 , 0 , 0 , 0 , 
     &     0 , 0 , 0 , 0 , 0 , -1 , -1 , -3 , -1 , -2 , -3 , -2 , -2 , 
     &     -3 , 1 , 3 , 3 , -1 , -3 , -3 , 2 , 3 , 3 , -2 , -3 , -3 , 
     &     3 , 3 , 3 , -3 , -3 , -3/
 
C / DTHAIC /
C (renamed) (HAdron InDex COnversion)
C translation table version filled up by r.e. 25.01.94                 *
      DATA IAMcin/2212 , -2212 , 11 , -11 , 12 , -12 , 22 , 2112 , 
     &     -2112 , -13 , 13 , 130 , 211 , -211 , 321 , -321 , 3122 , 
     &     -3122 , 310 , 3112 , 3222 , 3212 , 111 , 311 , -311 , 0 , 0 , 
     &     0 , 0 , 0 , 221 , 213 , 113 , -213 , 223 , 323 , 313 , -323 , 
     &     -313 , 10323 , 10313 , -10323 , -10313 , 30323 , 30313 , 
     &     -30323 , -30313 , 3224 , 3214 , 3114 , 3216 , 3218 , 2224 , 
     &     2214 , 2114 , 1114 , 12224 , 12214 , 12114 , 11114 , 99999 , 
     &     99999 , 22212 , 22112 , 32124 , 31214 , -2224 , -2214 , 
     &     -2114 , -1114 , -12224 , -12214 , -12114 , -11114 , -2124 , 
     &     -1214 , 4*99999 , 5*99999 , 5*99999 , 4*99999 , 331 , 333 , 
     &     3322 , 3312 , -3222 , -3212 , -3112 , -3322 , -3312 , 3224 , 
     &     3214 , 3114 , 3324 , 3314 , 3334 , -3224 , -3214 , -3114 , 
     &     -3324 , -3314 , -3334 , 421 , 411 , -411 , -421 , 431 , 
     &     -431 , 441 , 423 , 413 , -413 , -423 , 433 , -433 , 20443 , 
     &     443 , -15 , 15 , 16 , -16 , 14 , -14 , 4122 , 4232 , 4132 , 
     &     4222 , 4212 , 4112 , 3*99999 , 3*99999 , -4122 , -4232 , 
     &     -4132 , -4222 , -4212 , -4112 , 99999 , 5*99999 , 5*99999 , 
     &     5*99999 , 10*99999 , 5*99999 , 20211 , 20111 , -20211 , 
     &     99999 , 20321 , -20321 , 20311 , -20311 , 7*99999 , 7*99999 , 
     &     12212 , 12112 , 99999/
 
C / DTHAIC /
C (HAdron InDex COnversion)
      DATA (IPDg2(1,k),k=1,7)/ - 11 , -12 , -13 , -15 , -16 , -14 , 0/
      DATA (IBAm2(1,k),k=1,7)/4 , 6 , 10 , 131 , 134 , 136 , 0/
      DATA (IPDg2(2,k),k=1,7)/11 , 12 , 22 , 13 , 15 , 16 , 14/
      DATA (IBAm2(2,k),k=1,7)/3 , 5 , 7 , 11 , 132 , 133 , 135/
      DATA (IPDg3(1,k),k=1,22)/ - 211 , -321 , -311 , -213 , -323 , 
     &      -313 , -411 , -421 , -431 , -413 , -423 , -433 , 0 , 0 , 0 , 
     &      0 , 0 , 0 , 0 , 0 , 0 , 0/
      DATA (IBAm3(1,k),k=1,22)/14 , 16 , 25 , 34 , 38 , 39 , 118 , 119 , 
     &      121 , 125 , 126 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 
     &      0/
      DATA (IPDg3(2,k),k=1,22)/130 , 211 , 321 , 310 , 111 , 311 , 221 , 
     &      213 , 113 , 223 , 323 , 313 , 331 , 333 , 421 , 411 , 431 , 
     &      441 , 423 , 413 , 433 , 443/
      DATA (IBAm3(2,k),k=1,22)/12 , 13 , 15 , 19 , 23 , 24 , 31 , 32 , 
     &      33 , 35 , 36 , 37 , 95 , 96 , 116 , 117 , 120 , 122 , 123 , 
     &      124 , 127 , 130/
      DATA (IPDg4(1,k),k=1,29)/ - 2212 , -2112 , -3122 , -2224 , -2214 , 
     &      -2114 , -1114 , -2124 , -1214 , -3222 , -3212 , -3112 , 
     &      -3322 , -3312 , -3224 , -3214 , -3114 , -3324 , -3314 , 
     &      -3334 , -4122 , -4232 , -4132 , -4222 , -4212 , -4112 , 0 , 
     &      0 , 0/
      DATA (IBAm4(1,k),k=1,29)/2 , 9 , 18 , 67 , 68 , 69 , 70 , 75 , 
     &      76 , 99 , 100 , 101 , 102 , 103 , 110 , 111 , 112 , 113 , 
     &      114 , 115 , 149 , 150 , 151 , 152 , 153 , 154 , 0 , 0 , 0/
      DATA (IPDg4(2,k),k=1,29)/2212 , 2112 , 3122 , 3112 , 3222 , 3212 , 
     &      3224 , 3214 , 3114 , 3216 , 3218 , 2224 , 2214 , 2114 , 
     &      1114 , 3322 , 3312 , 3224 , 3214 , 3114 , 3324 , 3314 , 
     &      3334 , 4122 , 4232 , 4132 , 4222 , 4212 , 4112/
      DATA (IBAm4(2,k),k=1,29)/1 , 8 , 17 , 20 , 21 , 22 , 48 , 49 , 
     &      50 , 51 , 52 , 53 , 54 , 55 , 56 , 97 , 98 , 104 , 105 , 
     &      106 , 107 , 108 , 109 , 137 , 138 , 139 , 140 , 141 , 142/
      DATA (IPDg5(1,k),k=1,19)/ - 10323 , -10313 , -30323 , -30313 , 
     &      -12224 , -12214 , -12114 , -11114 , -20211 , -20321 , 
     &      -20311 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0/
      DATA (IBAm5(1,k),k=1,19)/42 , 43 , 46 , 47 , 71 , 72 , 73 , 74 , 
     &      188 , 191 , 193 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0/
      DATA (IPDg5(2,k),k=1,19)/10323 , 10313 , 30323 , 30313 , 12224 , 
     &      12214 , 12114 , 11114 , 22212 , 22112 , 32124 , 31214 , 
     &      20443 , 20211 , 20111 , 20321 , 20311 , 12212 , 12112/
      DATA (IBAm5(2,k),k=1,19)/40 , 41 , 44 , 45 , 57 , 58 , 59 , 60 , 
     &      63 , 64 , 65 , 66 , 129 , 186 , 187 , 190 , 192 , 208 , 209/
 
C / DTPAIN /
C internal particle names
      DATA BTYpe/'PROTON  ' , 'APROTON ' , 'ELECTRON' , 'POSITRON' , 
     &     'NEUTRIE ' , 'ANEUTRIE' , 'PHOTON  ' , 'NEUTRON ' , 
     &     'ANEUTRON' , 'MUON+   ' , 'MUON-   ' , 'KAONLONG' , 
     &     'PION+   ' , 'PION-   ' , 'KAON+   ' , 'KAON-   ' , 
     &     'LAMBDA  ' , 'ALAMBDA ' , 'KAONSHRT' , 'SIGMA-  ' , 
     &     'SIGMA+  ' , 'SIGMAZER' , 'PIZERO  ' , 'KAONZERO' , 
     &     'AKAONZER' , 'NEUTRIM ' , 'ANEUTRIM' , 'NEUTRIT ' , 
     &     'ANEUTRIT' , 'BLANK   '/
 
      END BLOCK DATA
